import * as React from 'react'
import {ExtraGlamorousProps} from './glamorous-component'
import {
  CSSPropertiesCompleteSingle,
  CSSPropertiesPseudo,
} from './css-properties'
import {SVGPropertiesCompleteSingle} from './svg-properties'

// This file is based off `./built-in-glamorous-components.d.ts`

// CSS tags

export const A: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLAnchorElement>
>
export const Abbr: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Address: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Area: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLAreaElement>
>
export const Article: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Aside: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Audio: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLAudioElement>
>
export const B: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Base: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLBaseElement>
>
export const Bdi: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Bdo: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Big: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Blockquote: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLQuoteElement>
>
export const Body: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLBodyElement>
>
export const Br: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLBRElement>
>
export const Button: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLButtonElement>
>
export const Canvas: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLCanvasElement>
>
export const Caption: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLTableCaptionElement>
>
export const Cite: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Code: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Col: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLTableColElement>
>
export const Colgroup: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLTableColElement>
>
export const Data: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLDataElement>
>
export const Datalist: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLDataListElement>
>
export const Dd: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Del: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLModElement>
>
export const Details: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Dfn: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Dialog: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Div: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLDivElement>
>
export const Dl: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLDListElement>
>
export const Dt: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Em: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Embed: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLEmbedElement>
>
export const Fieldset: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLFieldSetElement>
>
export const Figcaption: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Figure: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Footer: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Form: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLFormElement>
>
export const H1: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLHeadingElement>
>
export const H2: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLHeadingElement>
>
export const H3: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLHeadingElement>
>
export const H4: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLHeadingElement>
>
export const H5: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLHeadingElement>
>
export const H6: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLHeadingElement>
>
export const Head: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLHeadElement>
>
export const Header: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Hgroup: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Hr: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLHRElement>
>
export const Html: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLHtmlElement>
>
export const I: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Iframe: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLIFrameElement>
>
export const Img: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLImageElement>
>
export const Input: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLInputElement>
>
export const Ins: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLModElement>
>
export const Kbd: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Keygen: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Label: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLLabelElement>
>
export const Legend: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLLegendElement>
>
export const Li: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLLIElement>
>
export const Link: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLLinkElement>
>
export const Main: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Map: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLMapElement>
>
export const Mark: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Menu: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLMenuElement>
>
export const Menuitem: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Meta: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLMetaElement>
>
export const Meter: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLMeterElement>
>
export const Nav: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Noscript: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Object: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLObjectElement>
>
export const Ol: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLOListElement>
>
export const Optgroup: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLOptGroupElement>
>
export const Option: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLOptionElement>
>
export const Output: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLOutputElement>
>
export const P: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLParagraphElement>
>
export const Param: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLParamElement>
>
export const Picture: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLPictureElement>
>
export const Pre: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLPreElement>
>
export const Progress: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLProgressElement>
>
export const Q: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLQuoteElement>
>
export const Rp: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Rt: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Ruby: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const S: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Samp: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Script: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLScriptElement>
>
export const Section: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Select: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLSelectElement>
>
export const Small: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Source: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLSourceElement>
>
export const Span: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLSpanElement>
>
export const Strong: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Style: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLStyleElement>
>
export const Sub: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Summary: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Sup: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Table: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLTableElement>
>
export const Tbody: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLTableSectionElement>
>
export const Td: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLTableDataCellElement>
>
export const Textarea: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLTextAreaElement>
>
export const Tfoot: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLTableSectionElement>
>
export const Th: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLTableHeaderCellElement>
>
export const Thead: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLTableSectionElement>
>
export const Time: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLTimeElement>
>
export const Title: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLTitleElement>
>
export const Tr: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLTableRowElement>
>
export const Track: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLTrackElement>
>
export const U: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Ul: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLUListElement>
>
export const Var: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>
export const Video: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLVideoElement>
>
export const Wbr: React.StatelessComponent<
  CSSPropertiesCompleteSingle &
    CSSPropertiesPseudo &
    ExtraGlamorousProps &
    React.HTMLProps<HTMLElement>
>

// SVG tags

export const Circle: React.StatelessComponent<
  SVGPropertiesCompleteSingle &
    ExtraGlamorousProps &
    React.SVGAttributes<SVGCircleElement>
>
export const ClipPath: React.StatelessComponent<
  SVGPropertiesCompleteSingle &
    ExtraGlamorousProps &
    React.SVGAttributes<SVGClipPathElement>
>
export const Defs: React.StatelessComponent<
  SVGPropertiesCompleteSingle &
    ExtraGlamorousProps &
    React.SVGAttributes<SVGDefsElement>
>
export const Ellipse: React.StatelessComponent<
  SVGPropertiesCompleteSingle &
    ExtraGlamorousProps &
    React.SVGAttributes<SVGEllipseElement>
>
export const G: React.StatelessComponent<
  SVGPropertiesCompleteSingle &
    ExtraGlamorousProps &
    React.SVGAttributes<SVGGElement>
>
export const Image: React.StatelessComponent<
  SVGPropertiesCompleteSingle &
    ExtraGlamorousProps &
    React.SVGAttributes<SVGImageElement>
>
export const Line: React.StatelessComponent<
  SVGPropertiesCompleteSingle &
    ExtraGlamorousProps &
    React.SVGAttributes<SVGLineElement>
>
export const LinearGradient: React.StatelessComponent<
  SVGPropertiesCompleteSingle &
    ExtraGlamorousProps &
    React.SVGAttributes<SVGLinearGradientElement>
>
export const Mask: React.StatelessComponent<
  SVGPropertiesCompleteSingle &
    ExtraGlamorousProps &
    React.SVGAttributes<SVGMaskElement>
>
export const Path: React.StatelessComponent<
  SVGPropertiesCompleteSingle &
    ExtraGlamorousProps &
    React.SVGAttributes<SVGPathElement>
>
export const Pattern: React.StatelessComponent<
  SVGPropertiesCompleteSingle &
    ExtraGlamorousProps &
    React.SVGAttributes<SVGPatternElement>
>
export const Polygon: React.StatelessComponent<
  SVGPropertiesCompleteSingle &
    ExtraGlamorousProps &
    React.SVGAttributes<SVGPolygonElement>
>
export const Polyline: React.StatelessComponent<
  SVGPropertiesCompleteSingle &
    ExtraGlamorousProps &
    React.SVGAttributes<SVGPolylineElement>
>
export const RadialGradient: React.StatelessComponent<
  SVGPropertiesCompleteSingle &
    ExtraGlamorousProps &
    React.SVGAttributes<SVGRadialGradientElement>
>
export const Rect: React.StatelessComponent<
  SVGPropertiesCompleteSingle &
    ExtraGlamorousProps &
    React.SVGAttributes<SVGRectElement>
>
export const Stop: React.StatelessComponent<
  SVGPropertiesCompleteSingle &
    ExtraGlamorousProps &
    React.SVGAttributes<SVGStopElement>
>
export const Svg: React.StatelessComponent<
  SVGPropertiesCompleteSingle &
    ExtraGlamorousProps &
    React.SVGAttributes<SVGSVGElement>
>
export const Text: React.StatelessComponent<
  SVGPropertiesCompleteSingle &
    ExtraGlamorousProps &
    React.SVGAttributes<SVGTextElement>
>
export const Tspan: React.StatelessComponent<
  SVGPropertiesCompleteSingle &
    ExtraGlamorousProps &
    React.SVGAttributes<SVGTSpanElement>
>
